<?php

namespace Nest\Exceptions;

use function Nest\Utils\get_class_name_from_fullname;
use function Nest\Utils\str_remove_suffix;

/**
 * Generic class of a Nest exception.
 */
class Exception extends \Exception
{
	/**
	 * Get generic error ID from class name.
	 * @return string Error ID.
	 */
	public function getErrorId(): string
	{
		// Get the current exception class name and remove "Exception" suffix.
		return str_remove_suffix(get_class_name_from_fullname(get_class($this)), "Exception");
	}
}
