<?php

namespace Nest\Exceptions;

use Throwable;

/**
 * Thrown when an invalid class or object is passed to a function.
 */
class InvalidTypeException extends Exception
{
	/**
	 * @param string $expectedType The expected type.
	 * @param string $actualType The actual class or object type.
	 * @param int $code [optional] The Exception code.
	 * @param null|Throwable $previous [optional] The previous throwable used for the exception chaining.
	 */
	public function __construct(public string $expectedType, public string $actualType, int $code = 0, ?Throwable $previous = null)
	{
		parent::__construct("Expected type $this->expectedType, got $this->actualType.", $code, $previous);
	}
}
