<?php

namespace Nest\Exceptions\Services\Configuration;

use Nest\Exceptions\Services\ServiceException;
use Throwable;

/**
 * Exception thrown when an invalid service configuration is defined for a service.
 */
class InvalidServiceConfigurationDefinitionException extends ServiceException
{
	/**
	 * @param string $serviceConfigurationBaseClass Service configuration base class.
	 * @param string $givenServiceConfigurationClass Given service configuration class.
	 * @param int $code [optional] The Exception code.
	 * @param null|Throwable $previous [optional] The previous throwable used for the exception chaining.
	 */
	public function __construct(public string $serviceConfigurationBaseClass, public string $givenServiceConfigurationClass, int $code = 0, ?Throwable $previous = null)
	{
		parent::__construct("Invalid service configuration, expected {$this->serviceConfigurationBaseClass}, {$this->givenServiceConfigurationClass} given.", $code, $previous);
	}
}
