<?php

namespace Nest\Exceptions\Services\Configuration;

use Nest\Exceptions\Services\ServiceException;
use Throwable;

/**
 * Exception thrown when a requested service configuration is not defined.
 */
class UndefinedServiceConfigurationException extends ServiceException
{
	/**
	 * @param string $serviceConfigurationClass Requested service configuration.
	 * @param int $code [optional] The Exception code.
	 * @param null|Throwable $previous [optional] The previous throwable used for the exception chaining.
	 */
	public function __construct(public string $serviceConfigurationClass, int $code = 0, ?Throwable $previous = null)
	{
		parent::__construct("Undefined service configuration: {$this->serviceConfigurationClass}", $code, $previous);
	}
}
