<?php

namespace Nest\Exceptions;

use Throwable;

/**
 * Exception thrown when an instance method does not exists.
 */
class UnknownInstanceMethodException extends Exception
{
	/**
	 * @param string $className Class where method is not found.
	 * @param string $methodName Method not found.
	 * @param int $code [optional] The Exception code.
	 * @param null|Throwable $previous [optional] The previous throwable used for the exception chaining.
	 */
	public function __construct(public string $className, public string $methodName, int $code = 0, ?Throwable $previous = null)
	{
		parent::__construct("Cannot find $this->methodName in $this->className.", $code, $previous);
	}
}
