<?php

namespace Nest;

/**
 * Application paths builder.
 */
class Paths
{
	/**
	 * Create a new paths manager from its main path.
	 * @param string $appPath The main path of the application.
	 */
	public function __construct(protected string $appPath)
	{}

	/**
	 * Get main path of the application.
	 * @return string
	 */
	public function getAppPath(): string
	{
		return $this->appPath;
	}

	/**
	 * Get temporary files path.
	 * @return string
	 */
	public function getTempPath(): string
	{
		return "{$this->getAppPath()}/tmp";
	}

	/**
	 * Get configuration files path.
	 * @return string
	 */
	public function getConfigPath(): string
	{
		return "{$this->getAppPath()}/config";
	}
}
